module;

#include <cstdint>
#include <array>

export module image;

export template<class T, int Width, int Height> class Image {
public:
    void reset() {
        array = {};
    }

    decltype(auto) operator[](this auto& self, const int32_t x, const int32_t y) {
        return self.array[y * Width + x];
    }

    std::array<T, Width * Height> array = {};
};
